#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <string.h>
#include <ggi/graphlib.h>

int timeout=1;

int getic(void)
{ FILE *hand;
  int num,cnt;
  int c2=0;
  if ((hand=fopen("/proc/interrupts","r"))==NULL) 
    { perror("open /proc/interrupts"); 
      ggi_panic("Do you have /proc mounted ?\n"); }
  while(!feof(hand))
  { fscanf(hand,"%d:%d%*[^\n]",&num,&cnt);
    switch(num) /* Add other interrupts as you want it ... */
    { case 1: /* Keyboard */
      case 3: /* Mice on Com2/Com1 */
      case 4: c2+=cnt;break;
    }
  }
  fclose(hand);
  return(c2);
}

volatile int switchaway,switchto;

void MyEvHand(struct ggi_event ev)
{ if (ev.evdata.vt.subtype==VT_SWITCH_AWAY) switchaway++;
  if (ev.evdata.vt.subtype==VT_SWITCH_TO) switchto++; }

void blank_screen(void)
{ int c,lx,ly;
  double x,y,dx,dy;
  int xx[256],yy[256];

  srand(time(NULL));
  lx=x=320;ly=y=10;
  for(c=0;c<256;c++) xx[c]=yy[c]=5;
  ggi_setcolor(c=0);
  ggi_fillscreen();
  while(!switchaway&&!ggi_kbhit())
  { dx=(rand()%0x1ff)/255.0-1;
    dy=(rand()%0x3ff)/511.0-0.3;
    while(!switchaway&&!ggi_kbhit())
    { x+=dx;y+=dy;
      if (x<10||x>629) {dx=-dx;x+=dx;}
      if (y<10||y>389) {dy=-dy;y+=dy;}
      if (y<380) dy+=0.001;
      dx*=.9999;dy*=.9999;
      if (fabs(dx)<1e-2) break;
      if (lx==(int)x&&ly==(int)y) continue;
      c++;c&=0xff;if (!c) c++;
      ggi_setcolor(0);
      ggi_drawcircle(xx[c],yy[c],5);
      lx=xx[c]=x;ly=yy[c]=y;
      ggi_setcolor(c&0x0f);
      ggi_drawcircle(xx[c],yy[c],5);
/*      if (!(c&33)) usleep(1);*/
    }
  }
}

void go_crazy(void)
{ int x,y;

  for(x=-399;;)
  { if (switchaway||ggi_kbhit()) break;

    y=x;if (y<0) y=-y;

    ggi_setcolor(1);
    ggi_drawhline(0,y,320);

    ggi_setcolor(2);
    ggi_drawhline(320,399-y,320);

    if ((x&15)==0) usleep(1);
    ggi_setcolor(0);
    ggi_drawhline(0,y,320);
    ggi_drawhline(320,399-y,320);

    if (++x>399) x=-399;
  }
}


void pong(void)
{ int x,y,dx,dy,h;

  x=30;y=20;dx=1;dy=1;
  while(1)
  { if (switchaway||ggi_kbhit()) break;

    if (!(x&3)) usleep(1);
    if (x==634||x==5) dx=-dx;
    if (y==394||y==5) dy=-dy;
    ggi_setcolor(0);
    h=y;if (h<10) h=10;if (h>=390) h=389;
    ggi_drawbox(0,h-10,5,20);
    ggi_drawbox(634,h-10,5,20);
    ggi_drawcircle(x,y,3);
    ggi_drawcircle(x,y,2);
    ggi_drawcircle(x,y,1);
    x+=dx;y+=dy;
    ggi_setcolor(1);
    ggi_drawcircle(x,y,3);
    ggi_drawcircle(x,y,2);
    ggi_drawcircle(x,y,1);
    ggi_setcolor(2);
    h=y;if (h<10) h=10;if (h>=390) h=389;
    ggi_drawbox(0,h-10,5,20);
    ggi_setcolor(3);
    ggi_drawbox(634,h-10,5,20);

  }
}

void vesa_blank(void)
{ ggi_mon_power(PWR_STANDBY);
  while(!switchaway&&!ggi_kbhit());
  ggi_mon_power(PWR_ON); }

void vesa_blank2(void)
{ ggi_mon_power(PWR_SUSPEND);
  while(!switchaway&&!ggi_kbhit());
  ggi_mon_power(PWR_ON); }

void vesa_blank3(void)
{ ggi_mon_power(PWR_OFF);
  while(!switchaway&&!ggi_kbhit());
  ggi_mon_power(PWR_ON); }

struct scrsaver { void (*func)(void);
		  char *name; } SaverList[]=
		{ { blank_screen, "Jumping blob" },
		  { go_crazy,     "Crazy Lines"},
		  { pong,     	  "Ping Pong"},
		  { vesa_blank,   "Power Standby"},
		  { vesa_blank2,  "Power Suspend"},
		  { vesa_blank3,  "Power Off"},
		  { NULL       ,  NULL}		/* Terminator */
		   };

struct scrsaver *SaverActive=SaverList;

void do_saver(void)
{ int oldvt;
  switchaway=0;
  if ((oldvt=ggi_get_active_vt())<=0) return;
  ggi_vt_activate(0);
  ggi_setcolor(0);ggi_fillscreen();
  SaverActive->func();
  while(ggi_kbhit()) ggi_getch();
  if (!switchaway) ggi_vt_activate(oldvt);
}

void blank_screen2(void)
{ int c;
  switchaway=0;
  while(!switchaway)
  { for(c=0;c<400;c++)
    { ggi_setcolor(c/40+1);ggi_drawhline(0,c,640); }
    ggi_setcolor(15);
    ggi_printf(10,10, "*** Screen - Saver ***");
    ggi_printf(10,30, "Configuration Screen :");
    ggi_printf(10,50, "n/p Type: %15s",SaverActive->name);
    ggi_printf(10,70, "+/- Time: %4d minutes",timeout);
    ggi_printf(10,100,"Switch away to activate",timeout);
    switch(ggi_getch())
    { case '+': if (timeout<1440) timeout++;break;
      case '-': if (timeout>   1) timeout--;break;
      case 'p': if (SaverActive-SaverList>0) SaverActive--;break;
      case 'n': if ((SaverActive+1)->func) SaverActive++;break;
      case 'q': ggi_setcolor(0);ggi_exit();exit(0);
      case 't': do_saver();
    }
  }
}

int main(int argc,char *argv[])
{ int ic,ic2,cnt,x;

  ggi_init();
  ggi_register_evh(EV_ALL,MyEvHand);
  if (ggi_graphmode(640,400,640,400,GT_4BIT))
    ggi_panic("Cannot open default mode.");

  ic=cnt=0;
  switchto=1;
  
  if (argc>=2)
  { x=atoi(argv[1]);switchto=0;
    if (x>0&&x<1440 /* 1 Day ... */) timeout=x;
  }

  if (argc>=3)
  { x=atoi(argv[2]);
    if (x>=0&&x<sizeof(SaverList)/sizeof(SaverList[0]))
      SaverActive=SaverList+x;
  }
         
  while(1)
  { 
    if ((ic2=getic())==ic) 
    { if (++cnt>=timeout) 
      { do_saver();
        switchto=0;cnt=0;
      } 
    }
    else {cnt=0;ic=ic2;}
    
    if (!switchto) sleep(60);
    if (switchto) {blank_screen2();switchto=0;}
  }

  ggi_exit();
  return(0);
}
