/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include <ggi/graphdev.h>
#undef __KERNEL__

#define SETSIG2(sa, sig, fun, oldsa)	\
	sa.sa_handler = fun;		\
	sa.sa_flags = 0;		\
	sa.sa_mask = 0;			\
        sigaction(sig, &sa, &oldsa);

#if 1
int bad_user_access_length(void)
{return 0;}
#endif

int gd_hand=-1;				 /* Graphics device file handle	*/

struct sigaction old_handlers[NSIG];

int getsharedmem(void)
{ char name[100];
  key_t key;
  ramdaemon_shm shm_rq;

  ioctl(gd_hand,DRIVER_RAMDAEMON_ASK,&shm_rq);		/* Ask for the device */

/*  fprintf(stderr,"Self is %d.\n",shm_rq.self); */
  sprintf(name,"/dev/graph%d",shm_rq.self);
  key=ftok(name,'G');

  shm_rq.shmat = NULL;			/* No copy, if problems ... */
  shm_rq.shmid = shmget(key,0,0666);	
  if (-1 != shm_rq.shmid) 		/* if SHM exists, we map it */
  { shm_rq.shmat = shmat(shm_rq.shmid, NULL, 0);	/* attach it somewhere */
    if (shm_rq.shmat <= 0) 
    { fprintf(stderr,"Cannot attach shared memory.\n"); /* strange */ 
      shm_rq.shmat = NULL; }
  }

/*  if (shm_rq.shmat) fprintf(stderr,"GOT ONE : %p !\n",shm_rq.shmat);*/
  ioctl(gd_hand,DRIVER_RAMDAEMON_CPY,&shm_rq);
  
  shmdt(shm_rq.shmat);
        
  return 0;
}              

static void int_handler( int v )
{ struct sigaction siga;
  SETSIG2(siga, v, int_handler , old_handlers[SIGUSR1]);
  getsharedmem();
}

int main(void)
{ struct sigaction siga;

  SETSIG2(siga, SIGUSR1, int_handler , old_handlers[SIGUSR1]);

  /* Open the graphics device */
  if ((gd_hand=open("/dev/graphics",O_RDWR))==-1) {perror("open");exit(1);}
  if (ioctl(gd_hand,DRIVER_RAMDAEMON_INSTALL,NULL)) {perror("ioctl");exit(1);}

  for(;;) sleep(10000);
}

