/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define _LIB_COMPILE_

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <linux/vt.h>
#include <linux/kd.h>
#include <string.h>
#include <ggi/graphlib.h>


/********************************/
/* draw/get/put a vertical line */
/********************************/
int ggi_drawvline(int x,int y,int height)
{
	switchavail(GRAPHICS_DRAWVLINE,&x);

	switcha(GRAPHICS_DRAWVLINE)
	{ case AVM_MMAP :
		switch(CurrentMode.graphtype)
		{ case GT_8BIT:
			{ char *ptr;
	                   ptr=ggi_membuffer+y*CurrentMode.virtual.x+x;
	                   for(;height>0;height--,ptr+=CurrentMode.virtual.x) 
	                     *ptr=ggi_drwinfo.fg_color; }
	                break;
	          default:goto lower;
	        }
  		break;
	  case AVM_LOWER:lower:
	  	for(;height>0;height--) ggi_drawpixel(x,y++);
	  	break;
	  default       :
	  	ggi_panic("vline - no method.");break;
	}
	return(0);
}

int ggi_putvline(int x,int y,int height,void *buffer)
{
	switchavail(GRAPHICS_PUTVLINE,&x);

	switcha(GRAPHICS_PUTVLINE)
	{ case AVM_MMAP :
		switch(CurrentMode.graphtype)
		{ case GT_8BIT:
			{ char *ptr;
	                   ptr=ggi_membuffer+y*CurrentMode.virtual.x+x;
	                   for(;height>0;height--,ptr+=CurrentMode.virtual.x) 
	                     *ptr=*(char *)buffer++; }
	  		break;
	  	  default: goto lower;
	  	}
	  	break;
	  case AVM_LOWER: lower:
	  	for(;height>0;height--) {ggi_putpixel(x,y++,(char *)buffer++);}
	  	break;
	  default       :
	  	ggi_panic("vline - no method.");break;
	}
	return(0);
}

int ggi_getvline(int x,int y,int height,void *buffer)
{
	switchavail(GRAPHICS_GETVLINE,&x);

	switcha(GRAPHICS_GETVLINE)
	{ case AVM_MMAP :
		switch(CurrentMode.graphtype)
		{ case GT_8BIT:
			{ char *ptr;
	                   ptr=ggi_membuffer+y*CurrentMode.virtual.x+x;
	                   for(;height>0;height--,ptr+=CurrentMode.virtual.x) 
	                     *(char *)buffer++=*ptr; }
	                break;
	          default:goto lower;
	        }
  		break;
	  case AVM_LOWER:lower:
	  	for(;height>0;height--) {ggi_getpixel(x,y++,(char *)buffer++);}
	  	break;
	  default       :
	  	ggi_panic("vline - no method.");break;
	}
	return(0);
}

